//add data of admin
$(document).on("click","#addButton",function (){
    const overlay = document.getElementById("overlay_add");
    const formContainerAdd = document.getElementById("formContainer_add");

    // show
    overlay.classList.add("active");
    formContainerAdd.classList.add("active");
})

$(document).on("click","#addDevice",function (){
    var data={
        "hospitalId":localStorage.getItem('hospitalId'),
        "name":document.getElementById("addName").value,
        "type":document.getElementById("addType").value,
        "freeTime":document.getElementById("addFreeTime").value,
        "role":"HOSPITAL"
    }
    console.log(data)
    $.ajax({
        contentType: "application/json",
        url: "/device/insert",
        type: "POST",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if(data.code!=0){
                console.log(data.data)
                location.reload()
            }else {
                alert(data.msg)
            }
        },
    })
})




//create table to add data or update data
$(document).on("click","#edit",function (){

    const row = $(this).closest('tr');
    console.log(row.data('id'))
    let status=0;
    if(row.data('status')=="ACTIVE"){
        status=1
    }
    var data={
        "id":row.data('id'),
        "hospitalId":localStorage.getItem('hospitalId'),
        "name":row.data('name'),
        "type":row.data('type'),
        "freeTime":row.data('freeTime'),
    }

    //select By id (Data echo)
    $.ajax({
        contentType: "application/json",
        url: "/device/select",
        type: "POST",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if(data.code!=0){

                console.log(data.data)
                console.log(data.data[0].email)
                //Load form

                //padding data
                document.getElementById("id").value=data.data[0].id
                document.getElementById("hospitalId").value=data.data[0].hospitalId
                document.getElementById("name").value=data.data[0].name
                document.getElementById("type").value=data.data[0].type
                document.getElementById("freeTime").value=data.data[0].freeTime


                //Change css
                const overlay = document.getElementById("overlay");
                const formContainer = document.getElementById("formContainer");
                formContainer.classList.toggle("active"); // Toggle display status
                overlay.classList.toggle("active");
            }else {
                alert(data.msg)
            }
        },
    })
})

//submit Updated form data(Implement edit)
function submitForm(){

    var data={
        "type":"hospital",
        "id":document.getElementById("id").value,
        "hospitalId":document.getElementById("hospitalId").value,
        "name":document.getElementById("name").value,
        "type":document.getElementById("type").value,
        "freeTime":document.getElementById("freeTime").value,
    }
    console.log(data)
    $.ajax({
        contentType: "application/json",
        url: "/device/update",
        type: "PUT",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if(data.code!=0){

                console.log(data.data)
                location.reload()

            }else {
                alert(data.msg)
            }
        },
    })

}




$(document).on("click","#freeze",function (){
    const row = $(this).closest('tr');
    console.log(row.data('id'))
    var status;
    if(row.data('status')==="ACTIVE"){
        status=0;
    }else {
        status=1
    }
    var data={
        "id":row.data('id'),
        "type":"hospital",
        "hospitalId":localStorage.getItem('hospitalId'),
        "name":row.data('name'),
        "age":row.data('age'),
        "phone":row.data('phone'),
        "email":row.data('email'),
        "status":status,
    }
    $.ajax({
        contentType: "application/json",
        url: "/patient/update",
        type: "PUT",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {
            console.log(data)
            if(data.code==1){
                updateTable(data.data)
                location.reload()
            }else {
                alert(data.msg)
            }
        },

    });
})





$(document).on("click","#delete",function (){
    const clickedLabel = this;
    // remove active class
    const labels = document.querySelectorAll('.tdOption .btn');
    labels.forEach(label => label.classList.remove('active'));

    // add active class
    clickedLabel.classList.add('active');

    const row = $(this).closest('tr');
    // get data in row
    row.data('id');          // get ID
    let ids = new Array();
    ids.push(row.data('id'))
    console.log(ids)
    $.ajax({
        contentType: "application/json",
        url: "/device/deleteDeviceById",
        type: "DELETE",
        data: JSON.stringify(ids),
        dataType: "Json",
        success: function (data) {
            console.log(data)
            if(data.code==1){
                console.log(data)
                window.location.reload()
            }else {
                alert(data.msg)
            }
        },

    });

})

//reflash page
$(document).on("dblclick","#searchButton",function (){
    location.reload()
})


//use jQuery's load() to load content dynamically,Events cannot be bound in dom mode
$(document).on("click", "#searchButton", function () {
    let status=document.getElementById("searchStatus").value;

    if(status==="active"){
        status=1;
    }
    else if(status==="inactive"){
        status=0;
    }else {
        status=1;
    }

    var data={
        'name':document.getElementById("searchName").value,
        'type':document.getElementById("searchType").value,
        'hospitalId':localStorage.getItem("hospitalId")
        // 'email':document.getElementById("searchAddress").value,
    }
    $.ajax({
        contentType: "application/json",
        url: "/device/select",
        type: "POST",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if(data.code!=0){
                updateTable(data.data);
                // location.reload()
            }else {
                alert(data.msg)
            }
        },
    });
});

function updateTable(data) {
    let tbody = $("table tbody"); // choose table's tbody
    tbody.empty(); // clean old data
    console.log(data)
    // create new table
    data.forEach(row => {
        const tr = `
            <tr
            data-id="${row.id}"
            data-hospitalId="${row.hospitalId}"
            data-name="${row.name}"
            data-age="${row.type}"
            data-phone="${row.freeTime}">
                <td>${row.id}</td>
                <td>${row.hospitalId}</td>
                <td>${row.name}</td>
                <td>${row.type}</td>
                <td>${row.freeTime}</td>
                <td class="tdOption">
                <label id="edit" class="btn">Edit</label>
                <label id="delete" class="btn">Delete</label>
<!--                <label id="freeze" class="btn">Freeze</label>-->
            </td>
            </tr>
        `;
        tbody.append(tr);
    });
}