//add data of admin
$(document).on("click", "#addButton", function () {
    const overlay = document.getElementById("overlay_add");
    const formContainerAdd = document.getElementById("formContainer_add");

    // show
    overlay.classList.add("active");
    formContainerAdd.classList.add("active");
})

$(document).on("click", "#addAdmin", function () {
    var data = {
        "name": document.getElementById("addName").value,
        "password": document.getElementById("addPassword").value,
        "email": document.getElementById("addEmail").value,
        "phone": document.getElementById("addPhone").value,
        "type": "commonAdmin",
        "status": 1,
        "role": "ADMIN"
    }
    console.log(data)
    $.ajax({
        contentType: "application/json",
        url: "/superAdmin/sign",
        type: "POST",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if (data.code != 0) {
                console.log(data.data)
                location.reload()
            } else {
                alert(data.msg)
            }
        },
    })
})


//create table to add data or update data
$(document).on("click", "#edit", function () {

    const row = $(this).closest('tr');
    console.log(row.data('id'))
    let status = 0;
    if (row.data('status') == "ACTIVE") {
        status = 1
    }
    var data = {
        "id": row.data('id'),
        "type": "commonAdmin",
        "status": status
    }
    //select By id (Data echo)
    $.ajax({
        contentType: "application/json",
        url: "/superAdmin/select",
        type: "POST",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if (data.code != 0) {

                console.log(data.data)

                //Load form

                //padding data
                document.getElementById("name").value = data.data[row.data('id')-1].name
                document.getElementById("email").value = data.data[row.data('id')-1].email
                document.getElementById("phone").value = data.data[row.data('id')-1].phone
                document.getElementById("status").value = data.data[row.data('id')-1].status
                document.getElementById("id").value = data.data[row.data('id')-1].id

                //Change css
                const overlay = document.getElementById("overlay");
                const formContainer = document.getElementById("formContainer");
                formContainer.classList.toggle("active"); // Toggle display status
                overlay.classList.toggle("active");
            } else {
                alert(data.msg)
            }
        },
    })
})

//submit Updated form data(Implement edit)
function submitForm() {

    var data = {
        "type": "commonAdmin",
        "name": document.getElementById("name").value,
        "phone": document.getElementById("phone").value,
        "email": document.getElementById("email").value,
        "status": document.getElementById("status").value,
        "id": document.getElementById("id").value
    }

    $.ajax({
        contentType: "application/json",
        url: "/superAdmin/update",
        type: "PUT",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if (data.code != 0) {

                console.log(data.data)
                location.reload()

            } else {
                alert(data.msg)
            }
        },
    })

}


$(document).on("click", "#freeze", function () {
    const row = $(this).closest('tr');
    let status;
    if (row.data('status') === "ACTIVE") {
        status = 0;
    } else if (row.data('status') === "INACTIVE") {
        status = 1
    }
    var data = {
        "id": row.data('id'),
        "type": "commonAdmin",
        "name": row.data('name'),
        "phone": row.data('phone'),
        "email": row.data('email'),
        "status": status,
    }
    $.ajax({
        contentType: "application/json",
        url: "/superAdmin/update",
        type: "PUT",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {
            console.log(data)
            if (data.code == 1) {
                updateTable(data.data)
                //location.reload()
            } else {
                alert(data.msg)
            }
            location.reload()
        },

    });
})


$(document).on("click", "#delete", function () {

    const row = $(this).closest('tr');
    // get data in row
    row.data('id');          // get ID
    let ids = new Array();
    ids.push(row.data('id'))
    console.log(ids)
    $.ajax({
        contentType: "application/json",
        url: "/superAdmin/deleteAdminById",
        type: "DELETE",
        data: JSON.stringify(ids),
        dataType: "Json",
        success: function (data) {
            console.log(data)
            if (data.code == 1) {
                console.log(data)
                window.location.reload()
            } else {
                alert(data.msg)
            }
        },

    });

})

//reflash page
$(document).on("dblclick", "#searchButton", function () {
    location.reload()
})

//use jQuery's load() to load content dynamically,Events cannot be bound in dom mode
$(document).on("click", "#searchButton", function () {
    let status = document.getElementById("searchStatus").value;

    if (status === "active") {
        status = 1;
    } else if (status === "inactive") {
        status = 0;
    } else {
        status = 1;
    }


    var data = {
        'name': document.getElementById("searchName").value,
        'phone': document.getElementById("searchPhone").value,
        'type': "commonAdmin",
        'status': status
    }
    $.ajax({
        contentType: "application/json",
        url: "/superAdmin/select",
        type: "POST",
        data: JSON.stringify(data),
        dataType: "Json",
        success: function (data) {

            if (data.code != 0) {
                updateTable(data.data);
                //location.reload()
            } else {
                alert(data.msg)
            }
        },
    });
});


function updateTable(data) {
    let tbody = $("table tbody"); // choose table's tbody
    tbody.empty(); // clean old data
    // create new table
    data.forEach(row => {
        const tr = `
            <tr data-id="${row.id}"
            data-name="${row['name']}"
            data-phone="${row['phone']}"
            data-email="${row['email']}"
            data-status="${row['status_str']}">
                <td>${row.id}</td>
                <td>${row.name}</td>
                <td>${row.phone}</td>
                <td>${row.email}</td>
                <td>${row.status_str}</td>
            <td class="tdOption">
                <label id="edit" class="btn">Edit</label>
                <label id="delete" class="btn">Delete</label>
                <label id="freeze" class="btn">Change status</label>
            </td>
            </tr>
        `;
        tbody.append(tr);
    });
}

function pageSelect(pageSize,paginationDiv,pageNumber) {

    $.ajax({
        contentType: "application/json",
        url: `/superAdmin/pageSelect?type=commonAdmin&pageSize=${pageSize}&pageNumber=${pageNumber}`,
        type: "GET",
        dataType: "Json",
        success: function (data) {
            console.log(data)
            if (data.code != 0) {
                console.log(data.code)
                console.log(data.data)
                paginationDiv.innerHTML = ""; //clear old button
                for (let i = 1; i <= data.msg; i++) {
                    const button = document.createElement("button");
                    button.textContent = i;
                    button.style.margin = "0 5px";
                    button.style.padding = "5px 10px";
                    button.style.cursor = "pointer";
                    button.onclick = () => pageSelect(pageSize,paginationDiv,button.textContent);
                    paginationDiv.appendChild(button);
                }
                updateTable(data.data)
                //location.reload()
            } else {
                alert(data.msg)
            }
        },
    })
}

$(document).on("change","#page-size",function (){
    let pageSize=document.getElementById("page-size").value
    let paginationDiv = document.getElementById("pagination");
    pageSelect(pageSize,paginationDiv,"1");
})